<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class PenggunaanmakananValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		/* if(empty($input["kapalId"])){
			array_push($this->error, ["kapalId" => "cannot be null"]);
		}
		else{
			$lengthkapalid = strlen($input["kapalId"]);
			if($lengthkapalid>19){
				array_push($this->error, ["kapalid" => "value too long"]);
			}
		}
		$kapal= (new \App\Http\Models\KapalModel())->getQuery()->where("id","=",$input["kapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["kapalId" => "invalid relation"]);
		}
		if(empty($input["locationId"])){
			array_push($this->error, ["locationId" => "cannot be null"]);
		}
		else{
			$lengthlocationid = strlen($input["locationId"]);
			if($lengthlocationid>19){
				array_push($this->error, ["locationid" => "value too long"]);
			}
		}
		$lokasiitem= (new \App\Http\Models\LokasiitemModel())
			->getQuery()->where("id","=",$input["locationId"])->first();
		if(empty($lokasiitem)){
			array_push($this->error, ["locationId" => "invalid relation"]);
		}
		if(empty($input["approverId"])){
			array_push($this->error, ["approverId" => "cannot be null"]);
		}
		else{
			$lengthapproverid = strlen($input["approverId"]);
			if($lengthapproverid>19){
				array_push($this->error, ["approverid" => "value too long"]);
			}
		}
		$users= (new \App\Http\Models\UsersModel())
			->getQuery()->where("id","=",$input["approverId"])->first();
		if(empty($users)){
			array_push($this->error, ["approverId" => "invalid relation"]);
		}
		if(empty($input["requesterId"])){
			array_push($this->error, ["requesterId" => "cannot be null"]);
		}
		else{
			$lengthrequesterid = strlen($input["requesterId"]);
			if($lengthrequesterid>19){
				array_push($this->error, ["requesterid" => "value too long"]);
			}
		}
		$users= (new \App\Http\Models\UsersModel())
			->getQuery()->where("id","=",$input["requesterId"])->first();
		if(empty($users)){
			array_push($this->error, ["requesterId" => "invalid relation"]);
		}
		if(empty($input["destinationType"])){
			array_push($this->error, ["destinationType" => "cannot be null"]);
		}
		else{
			$lengthdestinationtype = strlen($input["destinationType"]);
			if($lengthdestinationtype>45){
				array_push($this->error, ["destinationtype" => "value too long"]);
			}
		}
 */
        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["kapalId"])){
			array_push($this->error, ["kapalId" => "cannot be null"]);
		}
		else{
			$lengthkapalid = strlen($input["kapalId"]);
			if($lengthkapalid>19){
			array_push($this->error, ["kapalid" => "value too long"]);
			}
		}
		if(!empty($input["kapalId"])){
		$kapal= (new \App\Http\Models\KapalModel())
			->getQuery()->where("id","=",$input["kapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["kapalId" => "invalid relation"]);
		}
		}
		if(empty($input["locationId"])){
			array_push($this->error, ["locationId" => "cannot be null"]);
		}
		else{
			$lengthlocationid = strlen($input["locationId"]);
			if($lengthlocationid>19){
			array_push($this->error, ["locationid" => "value too long"]);
			}
		}
		if(!empty($input["locationId"])){
		$lokasiitem= (new \App\Http\Models\LokasiitemModel())
			->getQuery()->where("id","=",$input["locationId"])->first();
		if(empty($lokasiitem)){
			array_push($this->error, ["locationId" => "invalid relation"]);
		}
		}
		if(empty($input["approverId"])){
			array_push($this->error, ["approverId" => "cannot be null"]);
		}
		else{
			$lengthapproverid = strlen($input["approverId"]);
			if($lengthapproverid>19){
			array_push($this->error, ["approverid" => "value too long"]);
			}
		}
		if(!empty($input["approverId"])){
		$users= (new \App\Http\Models\UsersModel())
			->getQuery()->where("id","=",$input["approverId"])->first();
		if(empty($users)){
			array_push($this->error, ["approverId" => "invalid relation"]);
		}
		}
		if(empty($input["requesterId"])){
			array_push($this->error, ["requesterId" => "cannot be null"]);
		}
		else{
			$lengthrequesterid = strlen($input["requesterId"]);
			if($lengthrequesterid>19){
			array_push($this->error, ["requesterid" => "value too long"]);
			}
		}
		if(!empty($input["requesterId"])){
		$users= (new \App\Http\Models\UsersModel())
			->getQuery()->where("id","=",$input["requesterId"])->first();
		if(empty($users)){
			array_push($this->error, ["requesterId" => "invalid relation"]);
		}
		}
		if(empty($input["destinationType"])){
			array_push($this->error, ["destinationType" => "cannot be null"]);
		}
		else{
			$lengthdestinationtype = strlen($input["destinationType"]);
			if($lengthdestinationtype>45){
				array_push($this->error, ["destinationtype" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

	}
	

	public function beforeApprove($input){
		if(empty($input["approverId"])){
			array_push($this->error, ["approverId" => "cannot be null"]);
		}
		else{
			$lengthapproverid = strlen($input["approverId"]);
			if($lengthapproverid > 19){
			array_push($this->error, ["approverid" => "value too long"]);
			}
		}
		if(!empty($input["approverId"])){
			$users= (new \App\Http\Models\UsersModel())
				->getQuery()->where("id","=",$input["approverId"])->first();
			if(empty($users)){
				array_push($this->error, ["approverId" => "invalid relation"]);
			}
		}
		if(empty($input["msNumber"])){
			array_push($this->error, ["msNumber" => "MS Number is not set"]);
		}

        return $this;
    }


}